'' This is a little demo to show how to use the pulse_on_off object
''
'' It uses the keyboard and TV (or VGA if changes indicated are made)
'' out to produce of variable on and off time on an output pin.
''
'' Graham Stabler 08/08/06


CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

VAR
 

OBJ

pulse   :       "pulse_on_off"    'my pulse generation object
tv      :       "tv"
kb      :       "keyboard"
text    :       "TV_text"   'for VGA change to VGA_Text and change pin number to 16 (see below)

PUB main | i,on_time,off_time,key,pin

  on_time := 100    ' initial on time
  off_time := 100   ' initial off time
  pin := 7          ' Output pin (if you are using TV, then you could flash one of the VGA leds p16-p23)
  text.start(12)    ' Start TV/VGA out (TV pins = 12, VGA = 16 on demo board)
  kb.start(26, 27)  ' Start keyboard
  pulse.start(on_time,off_time,pin)  'Start pulse generator object
  
   repeat  'loop forever and ever and ever
    text.str(string(13,"Pulse control screen",13,13,"On  time is: "))
    text.dec(on_time)
    text.str(string(13,"Off time is: "))
    text.dec(off_time)
    text.str(string(13,"Output pin is: "))
    text.dec(pin) 
    text.str(string(13,13,"Use arrow keys to adjust"))
    repeat while !kb.gotkey 'wait for a keypress
    case kb.getkey
      $C0: on_time := on_time - 10 #>14        ' Left arrow (limited to 14 clock cycles min)
      $C1: on_time := on_time + 10             ' Right arrow
      $C2: off_time := off_time + 10           ' Up arrow
      $C3: off_time := off_time - 10 #>57      ' Down arrow (limited to 57 clock cycles min)
    pulse.ontime(on_time)                      ' set new on_time
    pulse.offtime(off_time)                    ' set new off_time
    text.out($00)                              ' clear screen
    
    
      
    
  
    
  


pulse.start(100,1000,16)



repeat
  repeat i from 40 to 1000
    pulse.ontime(i)
    waitcnt(cnt+50000)
  repeat i from 1000 to 40
    pulse.ontime(i)
    waitcnt(cnt+50000)